"""    $Id$ """

from gluon.storage import Storage
from gluon.tools import PluginManager
dbui = local_import('plugin_dbui')


# define persistent data for the plugin and their default value
plugins = PluginManager('dbui',
                        field_modifiers={},
                        form_modifiers={},
                        grid_modifiers={},
                        viewport_modifiers=dbui.VIEWPORT_DP,
                        script_path='static/scripts',
                        user_src_path='static/src',
                        user_libmin=None)

# Start common services
dbSvc = dbui.DbSvc(globals())
cfgSvc = dbui.CfgSvc(globals())
directSvc = dbui.DirectSvc(globals())

# activate the debug mode
# this session variable is set by the control index or debug
dbSvc.debug = session.debug
cfgSvc.debug = session.debug
directSvc.debug = session.debug

# register method available on the client side
@directSvc.register
def getForm(tablename): 
    return cfgSvc.get_form(tablename)

@directSvc.register
def getGrid(tablename): 
    return cfgSvc.get_grid(tablename)

@directSvc.register
def getViewport(): 
    return cfgSvc.get_viewport()

@directSvc.register
def create(data): 
    return dbSvc.create(data)

@directSvc.register
def destroy(data): 
    return dbSvc.destroy(data)

@directSvc.register
def read(data): 
    return dbSvc.read(data)

@directSvc.register
def update(data): 
    return dbSvc.update(data)


