/**
 * grid_2.js
 *
 * To test and debug grid widget using MathJax
 * $Id$
 *
 */
Ext.namespace('App.grid');

/**
 * main function to get configuration information
 */
mainCfg = function(){

	// Expose the remote service cfgSvc
	Ext.Direct.addProvider(App.cfgSvcMethods);
	
	// Request form model from the server
	cfgSvc.get_grid_model('publications', mainGrid);
	
};

/**
 * main function to instantiate the grid
 * @param {Object} provider
 * @param {Object} response
 */
mainGrid = function(provider, response){

	var cfg = response.result;
	
//	console.log("Grid Model");
	console.dir(cfg.model.filterModel);

	// instantiate the grid and the filter
	var grid = Ext.ComponentMgr.create(cfg);
	var gridfilter = Ext.ComponentMgr.create(cfg.model.filterModel);
	gridfilter.bind(grid);

	// create the panel with the grid and gridfilter
	var panel = new Ext.Panel({
		layout: 'border',
		items: [{
			region: 'center',
			layout: 'fit',
			items: [grid],
		}, {
			region: 'east',
			layout: 'form',
			collapsible: true,
			collapsed: true,
			defaults: {anchor: '100%'},
			frame: true,
			items: [gridfilter],
			width: 300,
			split: true,
			buttons: [{text: 'reset',
					   ref: '../../resetButton'}],  // expose at the panel level
		}],
	});
	
	// Connect the reset button
	panel.resetButton.on('click', gridfilter.onReset, gridfilter);

	// the viewport to hold the grid
	// 	using all space available in the browser
	var vp = new Ext.Viewport({
		region: 'center',
		layout: 'fit',
		items: [panel],
	});
	
	vp.render('appmain');
};


Ext.onReady(function(){

    Ext.QuickTips.init();

	// load the MathJax library
	App.withMathJax ? App.loadMathJax(mainCfg) : mainCfg();

});